-- intercept.lua

-- TODO? check for valid pwd!

local interceptors = {}

function wrapped_function()
text = nil

if can_read_state() ~= "yes" then
	return
end

reset_pageload_cache()

path = requestpath -- temporary workaround for backwards compatibility
query = requestquery -- temporary workaround for backwards compatibility

if not locked() then
	-- Download and cache available skills. Do this differently(?)
	get_skills()
end

if requestpath == "/manor3.php" then
	determine_cellar_wines()
end

if requestpath == "/automate-tiles" then
	text, url = automate_tiles()
end

-- 			let inrunoption = case choice of
-- 				21 -> 2 -- not trapped in the wrong body
-- 				46 -> 3 -- fight vampire, maybe doubtful?
-- 				105 -> 1 -- gaze into mirror in bathroom
-- 				108 -> 4 -- walk away from craps
-- 				109 -> 1 -- fight hobo
-- 				110 -> 4 -- introduce them to avantgarde
-- 				113 -> 2 -- fight knob goblin chef
-- 				118 -> 2 -- don't do wounded guard quest
-- 				120 -> 4 -- ennui outta here
-- 				123 -> 2 -- raise your hands in hidden temple
-- 				177 -> 5 -- blackberry cobbler, leave
-- 				402 -> 2 -- don't hold a grudge in bathroom, gain myst
-- 				otherwise -> -1
-- 			let aftercoreoption = case choice of
-- 				9 -> 3 -- leave the wheel alone in the castle
-- 				10 -> 3 -- leave the wheel alone in the castle
-- 				11 -> 3 -- leave the wheel alone in the castle
-- 				12 -> 3 -- leave the wheel alone in the castle
-- 				21 -> -1 -- trapped in the wrong body?
-- 				26 -> 2 -- take the scorched path
-- 				28 -> 2 -- investigate the moist crater for spices
-- 				89 -> 2 -- fight TT knight in the gallery
-- 				90 -> 2 -- watch the dancers in ballroom
-- 				112 -> 2 -- no time for harold's bell
-- 				178 -> 2 -- blow popsicle stand in airship
-- 				182 -> 1 -- fight in the airship
-- 				207 -> 2 -- leave hot door alone in burnbarrel
-- 				213 -> 2 -- leave piping hot in burnbarrel
-- 				214 -> 1 -- kick stuff into the hole in the heap
-- 				216 -> 2 -- begone from the compostal service
-- 				otherwise -> inrunoption

if requestpath == "/inv_use.php" then
	if character["automate simple tasks"] == "yes" then
		item = get_item_data_by_id(tonumber(params.whichitem))
		if item then
			if item.name == "Degrassi Knoll shopping list" then
				stuff = {}
				stuff["bitchin' meatcar"] = { "meat engine", "dope wheels" }
				stuff["dope wheels"] = { "tires", "sweet rims" }
				stuff["meat engine"] = { "cog and sprocket assembly", "full meat tank" }
				stuff["cog and sprocket assembly"] = { "sprocket assembly", "cog" }
				stuff["sprocket assembly"] = { "spring", "sprocket" }
				stuff["full meat tank"] = { "empty meat tank", "meat stack" }
				can_buy = {}
				if moonsign_area() == "Degrassi Knoll" then
					can_buy["tires"] = true
					can_buy["cog"] = true
					can_buy["spring"] = true
					can_buy["sprocket"] = true
					can_buy["empty meat tank"] = true
				end
				can_buy["meat stack"] = true
				function combine_tables(a, b)
					ret = {}
					for x, y in pairs(a) do table.insert(ret, y) end
					for x, y in pairs(b) do table.insert(ret, y) end
					return ret
				end
				function try_to_create(name)
	-- 					print("try_to_create", name)
					if have(name) then
						return { have = { name }, buy = {}, missing = {}, order = {} }
					end
					if can_buy[name] then
	-- 						print("buying", name)
						return { have = {}, buy = { name }, missing = {}, order = {} }
					end
					if stuff[name] then
	-- 						print(name, "pasting", stuff[name][1], stuff[name][2])
						local a = try_to_create(stuff[name][1])
						local b = try_to_create(stuff[name][2])
						local have = combine_tables(a.have, b.have)
						local buy = combine_tables(a.buy, b.buy)
						local missing = combine_tables(a.missing, b.missing)
						local order = combine_tables(a.order, b.order)
						table.insert(order, { stuff[name][1], stuff[name][2] })
	-- 						print(name, "pasted", printstr(have), printstr(buy), printstr(missing), printstr(order))
						return { have = have, buy = buy, missing = missing, order = order }
					end
	-- 					print("missing", name)
					return { have = {}, buy = {}, missing = { name }, order = {} }
				end
				meatcar = try_to_create("bitchin' meatcar")
	-- 				print("need to buy", printstr(meatcar.buy))
	-- 				print("missing", printstr(meatcar.missing))
				if next(meatcar.missing) then
					local missing_list = {}
					for a, b in pairs(meatcar.missing) do table.insert(missing_list, [[<span style="color: darkorange;">]] .. b .. [[</span>]]) end
					for a, b in pairs(meatcar.buy) do table.insert(missing_list, [[<span style="color: gray;">]] .. b .. [[</span>]]) end
					for a, b in pairs(meatcar.have) do table.insert(missing_list, [[<span style="color: green;">]] .. b .. [[</span>]]) end
					text, url = get_page("/inv_use.php", params):gsub("<blockquote>.+</blockquote>", "<blockquote>Needed items:<p><blockquote><p>" .. table.concat(missing_list, "<br>") .. "</p></blockquote></blockquote>")
				else
					for x, name in pairs(meatcar.buy) do
	-- 						print("buying", name)
						if name == "meat stack" then
							async_get_page("/inventory.php", { quantity = 1, action = "makestuff", pwd = params.pwd, whichitem = get_itemid(name), ajax = 1 })
						else
							async_get_page("/store.php", { phash = params.pwd, buying = 1, whichitem = get_itemid(name), howmany = 1, whichstore = "5", ajax = 1, action = "buyitem" })
						end
					end
					for x, name in pairs(meatcar.order) do
	-- 						print("pasting", name[1], name[2])
						meatpaste_items(name[1], name[2])
					end

					async_get_page("/town_right.php", { place = "untinker" })
					async_get_page("/knoll.php", { place = "smith" })
					async_get_page("/town_right.php", { place = "untinker" })
					async_get_page("/guild.php", { place = "paco" }) -- need the topmenu refreshed from this
					text, url = get_page("/inv_use.php", params)
					async_post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = get_itemid("bitchin' meatcar") })
					async_post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = get_itemid("dope wheels") })

					text = "<script>parent.menupane.location.href=parent.menupane.location.href;</script>" .. text -- do in a prettier way?
				end
			end
			if item.name == "black market map" then -- TODO: make this an automator?
				-- TODO: add Bee path support?
				local famid = familiarid()
				async_get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = 59 }) -- blackbird
				text, url = get_page(requestpath, params)
				async_get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = famid })
			end
		end
	end
end

for _, x in ipairs(interceptors[requestpath] or {}) do
	local t, u = x.f()
	if t then
		return t, u
	end
end

if text then
-- 	print "intercept:returning"
	return text, url
else
-- 	print "intercept:rawsubmitting"
	return raw_submit_page(request_type, requestpath, parse_params_raw(input_params))
end

end




local envstoreinfo = loadfile("scripts/setup-environment.lua")()

function dofile(f)
	load_script("../" .. f)
end

load_script("base/util.lua")

envstoreinfo.g_env.setup_functions()
tostring = envstoreinfo.g_env.tostring

local function add_interceptor_raw(file, func)
	if not interceptors[file] then interceptors[file] = {} end
	table.insert(interceptors[file], { f = func })
end

envstoreinfo.g_env.load_script_files {
	add_interceptor = add_interceptor_raw,
}

function run_wrapped_function(f_env)
	envstoreinfo.f_store = f_env
	envstoreinfo.f_store.input_params = envstoreinfo.f_store.raw_input_params
	envstoreinfo.f_store.params = envstoreinfo.g_env.parse_params(envstoreinfo.f_store.raw_input_params)

	envstoreinfo.store_target = envstoreinfo.f_store
	envstoreinfo.store_target_name = "f_store"
	return wrapped_function()
end

return run_wrapped_function
